<?
function LoadJPEG ($imgURL) {
	#echo "LoadJPEG($imgURL)"."<br />";
	##-- Get Image file from Port 80 --##
	$imageFile = file_get_contents($imgURL); #fread ($fp, 3000000);
	
	##-- Create a temporary file on disk --##
	$tmpfname = './images/tmp.jpg';
	
	##-- Put image data into the temp file --##
	$fp = fopen($tmpfname, "w");
	fwrite($fp, $imageFile);
	fclose($fp);
	
	##-- Load Image from Disk with GD library --##
	$im = imagecreatefromjpeg ($tmpfname);
	
	##-- Delete Temporary File --##
	unlink($tmpfname);
	
	##-- Check for errors --##
	if (!$im) {
	    print "Could not create JPEG image $imgURL";
	}
	
	return $im;
}
function LoadPNG ($imgURL) {
	#echo "LoadPNG($imgURL)"."<br />";
	
	##-- Get Image file from Port 80 --##
	$imageFile = file_get_contents($imgURL); #fread ($fp, 3000000);
	
	##-- Create a temporary file on disk --##
	$tmpfname = './images/tmp.png';
	
	##-- Put image data into the temp file --##
	$fp = fopen($tmpfname, "w");
	fwrite($fp, $imageFile);
	fclose($fp);
	
	##-- Load Image from Disk with GD library --##
	$im = imagecreatefrompng($tmpfname);
	
	##-- Delete Temporary File --##
	unlink($tmpfname);
	
	##-- Check for errors --##
	if (!$im) {
	    print "Could not create JPEG image $imgURL";
	}
	
	return $im;
}
function ClearJPG(){
	$folder = dir('./images/');
	$fcount = 0;
	while ($dateiname = $folder->read()) {
		if (@filetype('./images/'.$dateiname) != "dir") {
			$fcount++;
		}
	}
	$folder->close();
  if($fcount > 0){  
		$fileArray = array();
		foreach (glob("./images/*") as $filename) {
		  $diff = time() - fileatime($filename); // fileatime liefert den Unixtimestamp des letzten Zugriffs auf eine Datei
		  if($diff > 1800) { // 1800 = 60 sec * 30 min
		    unlink($filename);
		  }
		}
	}
}
function ClearPDF(){
	$folder = dir('./PDFs/');
	$fcount = 0;
	while ($dateiname = $folder->read()) {
		if (@filetype($dir.$dateiname) != "dir") {
			$fcount++;
		}
	}
	$folder->close();
  if($fcount > 0){  
		$fileArray = array();
		foreach (glob("./PDFs/*") as $filename) {
		  $diff = time() - fileatime($filename); // fileatime liefert den Unixtimestamp des letzten Zugriffs auf eine Datei
		  if($diff > 1800) { // 1800 = 60 sec * 30 min
		    unlink($filename);
		  }
		}
	}
}

ClearJPG();
ClearPDF();
    
$br = "<br />";
$json= '[{"type":"jpg","imageurl":"http:\/\/pdf.basic4android.de\/20140126_100310.jpg","action":"init"},';
$json .= '{"g":0,"text":"Zora","angle":0,"b":0,"r":255,"font":"arial.ttf","action":"SetText","y":700,"size":50,"x":650},';
$json .= '{"text":"Lucky","angle":260,"r":255,"g":255,"b":255,"font":"arial.ttf","action":"SetText","y":210,"size":50,"x":700},';
$json .= '{"g":255,"text":"Charly","angle":30,"b":255,"r":255,"font":"arial.ttf","action":"SetText","y":500,"size":50,"x":250},';
$json .= '{"name":"Charly","r":255,"g":255,"b":255,"action":"copy2jpg","x":250,"y":500,"w":250,"h":250},';

$json .= '{"angle":0,"src_h":84,"src_w":155,"action":"SetImage","src_x":0,"src_y":0,"type":"png","imageurl":"http:\/\/www.basic4ppc.com\/new_images\/b4a_logo.png","dst_x":220,"dst_y":330}]';
if (isset($_REQUEST['DeviceID'])){$DeviceID=trim($_REQUEST['DeviceID']);} else {$DeviceID="0";}
if (isset($_REQUEST['json'])){$json=stripcslashes(trim($_REQUEST['json']));}

#echo "DeviceID = ".$DeviceID.$br;
#echo "json = ".$json.$br;

$copy2 = array();

$jsonarr = json_decode($json, true);
foreach(json_decode($json, true) as $action) {
	if (trim($action['action']) != ""){
		#echo "Action = ".trim(strtolower($action['action'])).$br;
		#echo "=================================".$br;
		$todo = trim(strtolower($action['action']));
		if ($todo == "init"){
		  #echo $action['imageurl'].$br;
			#echo "GridSize = ".intval(trim(strtolower($action['grid']))).$br;

			if (trim($action['destinationname']) != ""){
				$destinationname = trim($action['destinationname']);
			} else {
				$destinationname =  date("Ymd_His", time()).'_'.$DeviceID;
			}

			if (trim(strtolower($action['type'])) == "jpg"){
				$img = LoadJPEG($action['imageurl']);
			} else if (trim(strtolower($action['type'])) == "png"){
				$img = LoadPNG($action['imageurl']);
			}

			foreach($action AS $fname => $fvalue){
				#echo $fname." = ".$fvalue.$br;
			}
		}
		if ($todo == "copy2jpg"){
			foreach($action AS $fname => $fvalue){
				if (strtolower($fname) == "x"){
					$cpx = intval($fvalue);
				} elseif (strtolower($fname) == "y"){
					$cpy = intval($fvalue);
				} elseif (strtolower($fname) == "w"){
					$cpw = intval($fvalue);
				} elseif (strtolower($fname) == "h"){
					$cph = intval($fvalue);
				} elseif (strtolower($fname) == "name"){
  				$cpname  = $fvalue;					 
				} elseif (strtolower($fname) == "action"){
				}else{
					#echo strtolower($fname)." = ".$fvalue.$br;
				}
			}
			$copy2jpg = ImageCreate(intval($action['w']),intval($action['h']));
			ImageCopy ( $copy2jpg, $img, 0, 0, intval($action['x']), intval($action['y']), intval($action['w']), intval($action['h']));
			
			// create JPG 
			$destination =$destinationname.'_'.$cpname.'.jpg';
			// Save the image to file.jpg
			imagejpeg($copy2jpg, './images/'.$destination);
			// Destroy image
			imagedestroy($copy2jpg); 
			// Store filename in array to give this list later back to the app...
			$copy2[] = 'http://pdf.basic4android.de/images/'.$destination;
		}
		if ($todo == "copy2png"){
			foreach($action AS $fname => $fvalue){
				if (strtolower($fname) == "x"){
					$cpx = intval($fvalue);
				} elseif (strtolower($fname) == "y"){
					$cpy = intval($fvalue);
				} elseif (strtolower($fname) == "w"){
					$cpw = intval($fvalue);
				} elseif (strtolower($fname) == "h"){
					$cph = intval($fvalue);
				} elseif (strtolower($fname) == "name"){
  				$cpname  = $fvalue;					 
				} elseif (strtolower($fname) == "action"){
				}else{
					#echo strtolower($fname)." = ".$fvalue.$br;
				}
			}
			$copy2png = ImageCreate(intval($action['w']),intval($action['h']));
			ImageCopy ( $copy2png, $img, 0, 0, intval($action['x']), intval($action['y']), intval($action['w']), intval($action['h']));
			
			// create PNG
			$destination = date("Ymd_His", time()).'_'.$DeviceID.'_'.$cpname.'.png';
			// Save the image to file.jpg
			imagepng($copy2jpg, './images/'.$destination);
			// Destroy image
			imagedestroy($copy2jpg); 
			// Store filename in array to give this list later back to the app...
			$copy2[] = 'http://pdf.basic4android.de/images/'.$destination;
		}

		if ($todo == "setlogo"){
			#echo "GridSize = ".intval(trim(strtolower($action['grid']))).$br;
			foreach($action AS $fname => $fvalue){
				if (strtolower($fname) == "x"){
					$logox = intval($fvalue);
				} elseif (strtolower($fname) == "y"){
					$logoy = intval($fvalue);
				} elseif (strtolower($fname) == "w"){
					$logow = intval($fvalue);
				} elseif (strtolower($fname) == "h"){
					$logoh = intval($fvalue);
				} elseif (strtolower($fname) == "image"){
					if (file_exists($fvalue)) {
  					$logoimage = $fvalue;					 
					}
				} elseif (strtolower($fname) == "action"){
				}else{
					#echo strtolower($fname)." = ".$fvalue.$br;
				}
			}
			#echo "x = ".$logox.$br;
			#echo "y = ".$logoy.$br;
			#echo "w = ".$logow.$br;
			#echo "h = ".$logoh.$br;
			#echo "image = ".$logoimage.$br;
			#foreach($action AS $fname => $fvalue){
			#	echo $fname." = ".$fvalue."<br />";
			#}
		}
		if ($todo == "line"){
			$linecolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imageline($img,intval($action['x1']),intval($action['y1']),intval($action['x2']),intval($action['y2']),$linecolor);
		}
		if ($todo == "dashedline"){
			$linecolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imagedashedline($img,intval($action['x1']),intval($action['y1']),intval($action['x2']),intval($action['y2']),$linecolor);
		}
		if ($todo == "filledrect"){
			$fillcolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imagefilledrectangle ($img,intval($action['x1']),intval($action['y1']),intval($action['x2']),intval($action['y2']),$fillcolor);
		}
		if ($todo == "rect"){
			$rectcolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imagerectangle($img,intval($action['x1']),intval($action['y1']),intval($action['x2']),intval($action['y2']),$rectcolor);
		}
		if ($todo == "ellipse"){
			$ellipsecolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imageellipse($img,intval($action['x']),intval($action['y']),intval($action['w']),intval($action['h']),$ellipsecolor);
		}
		if ($todo == "filledellipse"){
			$ellipsecolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
			imagefilledellipse($img,intval($action['x']),intval($action['y']),intval($action['w']),intval($action['h']),$ellipsecolor);
		}

		if ($todo == "settext"){
		  #echo 'settext('.$action['x'].','.$action['y'].','.$action['size'].','.$action['r'].','.$action['g'].','.$action['b'].','.$action['font'].','.$action['text'].')'.$br;
			if(isset($action['text'])){
				$textcolor = ImageColorAllocate ($img, intval($action['r']), intval($action['g']), intval($action['b']));
				imagettftext ($img, intval($action['size']) , intval($action['angle']) , intval($action['x']), intval($action['y'])+intval($action['size'])  , $textcolor , './font/'.strtolower($action['font']) , $action['text'] );
			}
		}
		if ($todo == "setimage"){
		  #echo 'url='.$action['imageurl'].$br;
			if (trim(strtolower($action['type'])) == "jpg"){
				$dummy = LoadJPEG($action['imageurl']);
			} else if (trim(strtolower($action['type'])) == "png"){
				$dummy = LoadPNG($action['imageurl']);
			}
		  #echo 'imagecopy(img,dummy,'.$action['dst_x'].','.$action['dst_y'].','.$action['src_x'].','.$action['src_y'].','.$action['src_w'].','.$action['src_h'].')'.$br;
		  if(intval($action['angle']) != 0){
		  	$transparent = imagecolorallocatealpha($img, 0, 0, 0, 127);
		  	$dummy = imagerotate($dummy,intval($action['angle']),$transparent);
		  }
		  imagecopy($img, $dummy, $action['dst_x'], $action['dst_y'], $action['src_x'], $action['src_y'], $action['src_w'], $action['src_h']);
			// Destroy image
			imagedestroy($dummy); 
		}
	}
	#echo "<br />";
}
$destination = date("Ymd_His", time()).'_'.$DeviceID.'.jpg';

// Save the image to file.png
imagejpeg($img, './images/'.$destination);

// Destroy image
imagedestroy($img); 

$res = array();
$res["resultcode"] = 0;
$res["image"] = 'http://pdf.basic4android.de/images/'.$destination;
if(sizeof($copy2) > 0){
	$res["newimages"] = $copy2;
}
echo json_encode($res);
#echo '<a href="images/'.$destination.'" target="_blank">Image</a>';;

?>